import 'dart:async';

Stream<int> generate(int start, int end, Duration duration) async* {
  for (int i = start; i <= end; i++) {
    yield i;
    await Future.delayed(duration);
  }
}

void main() {
  final stream = generate(1, 9, Duration(seconds: 1));
  final subscription = stream | print;
}

extension StreamPipeExtension<T> on Stream<T> {
  StreamSubscription operator |(Function(T) func) => this.listen(func);
}
